
//Script associated to 10Hz stimulation....

//The experiment is composed by .... only entrainment of 10 Hz and trials finishing at specific phases
#include "sine_table-10Hz-0.h"
//Constants
const int ledPin = 3;        // pin with the oscilations
const int ledPin2= 13;       // inter trial led
const int Pulsador = 5; 
const int trials_per_block=60; 
const int delays = 1000;  //   1KHz sampling freq ... time for the interruption 

// // Pins with marks to biosemi
// // MARKS ASSOCIATED to conditions 
const int mark5=14;
const int mark6=15;
const int mark7=16;
const int mark8=17;   

int samples = (sizeof(sinTable_value)/sizeof(sinTable_value[0]));
const int time_end_phase1= samples; 
const int time_end_phase2= samples; 
const int time_end_phase3= samples;
const int time_end_phase4=samples; 

//VARIABLES  VOLATILES
volatile int block_number=1; 
volatile int trial_type;
int time_in_trial = 0; 
volatile int trial_number=0; 
volatile int flagFinish=0;   
volatile boolean Estado; 
volatile boolean Flag_Ready_ToBe_Pushed;   

int time5secs =0;  
int time_target=-1;
IntervalTimer myTimer; 

// this array has numbers between 4-7 representing that each block has 15 trials per condition (4 conditions)  60 trials per block. To complete 45 trials per condition we need 3 blocks
const int Block1_random_conditions []={7,5,4,6,4,4,4,4,5,4,7,7,5,5,6,4,7,4,5,7,5,5,6,4,6,6,7,7,6,7,7,6,5,5,4,6,5,4,5,6,7,5,6,7,6,7,6,5,5,4,6,4,4,5,7,7,7,6,4,6}; //random conditions for block 1
const int Block2_random_conditions []={5,6,4,6,7,5,5,5,7,5,6,7,7,4,7,7,7,5,5,5,4,6,4,6,4,5,6,6,5,7,4,4,5,7,6,6,6,7,6,6,4,4,6,4,7,5,5,6,7,4,4,5,7,7,5,4,4,6,7,4}; //random conditions for block 2
const int Block3_random_conditions []={6,7,7,5,5,5,6,4,7,7,5,6,6,6,5,7,6,6,4,7,6,7,7,5,6,6,4,5,6,4,6,5,4,5,5,4,5,4,4,4,4,7,5,7,7,5,4,4,7,4,5,7,6,6,7,4,6,5,4,7}; //random conditions for block 3

void setup() {
  pinMode(ledPin, OUTPUT);            
  pinMode(ledPin2, OUTPUT);           
  pinMode(Pulsador, INPUT);           
  pinMode(mark5, OUTPUT);           
  pinMode(mark6, OUTPUT);           
  pinMode(mark7, OUTPUT);           
  pinMode(mark8, OUTPUT);            
  analogWriteFrequency(ledPin, 1000); 
  myTimer.priority(0);
  myTimer.begin(sinLED, delays);  
  Flag_Ready_ToBe_Pushed=true;
  Estado=false;
}

void sinLED() 
{ 
  
  if ((Estado==true && Flag_Ready_ToBe_Pushed==true) || ( (Estado==true) && (trial_number>=0) && (trial_number<trials_per_block )))
  {
    if (flagFinish !=1) {
          if (time_in_trial==0 ) 
          {
            switch( block_number)
           { 
          case 1:
            trial_type= Block1_random_conditions[trial_number];
          break;
          case 2:
            trial_type= Block2_random_conditions[trial_number];
          break;
          case 3:
            trial_type= Block3_random_conditions[trial_number];
          break;
           }
           
            Flag_Ready_ToBe_Pushed=false;           
                      
            switch (trial_type)
            {
              case 4:
                time5secs=time_end_phase1;
                digitalWrite(mark5,HIGH);
                analogWrite(ledPin,sinTable_value[time_in_trial]);  
              break;
              case 5:
                time5secs=time_end_phase2;
                digitalWrite(mark6,HIGH);
                analogWrite(ledPin,sinTable_value[time_in_trial]);  
              break;
              case 6:
                time5secs=time_end_phase3;
                digitalWrite(mark7,HIGH);
                analogWrite(ledPin,sinTable_value[time_in_trial]);  
              break;
              case 7:
                time5secs=time_end_phase4;
                digitalWrite(mark8,HIGH);
                analogWrite(ledPin,sinTable_value[time_in_trial]); 
              break;              
            }
            time_in_trial=time_in_trial+1;                
          }
          else if (time_in_trial == time5secs)  
          { 
            trial_number=trial_number+1;  
            time_in_trial=0;              
            flagFinish=1;                 
            analogWrite(ledPin,0);        
            if(trial_number==trials_per_block)        
              {
                block_number+=1;        
                Flag_Ready_ToBe_Pushed=true;        
                Estado=false;           
                trial_number=0;        
              }   
    
          }
           
          else               
          {          
               if (time_in_trial==2)
                { 
                  switch (trial_type)
                  {
                    case 4:
                      digitalWrite(mark5,LOW);
                      break;
                    case 5:
                      digitalWrite(mark6,LOW);
                      break;
                    case 6:
                      digitalWrite(mark7,LOW);
                      break;
                    case 7:
                      digitalWrite(mark8,LOW);
                      break;
                  }
                }
                analogWrite(ledPin,sinTable_value[time_in_trial]); 
                time_in_trial=time_in_trial+1;    
        }
                              
    }      
  }
}
  
void loop() {
  unsigned long flagFinishCopy;  
//  if(Flag_Ready_ToBe_Pushed) 
//  {
//    Estado = digitalRead(Pulsador);  
//    delay(10);
//  }

    Estado = 1;
  
  noInterrupts();
  flagFinishCopy = flagFinish;
  interrupts();
  
  if (flagFinishCopy==1)
  {
    digitalWrite(ledPin2,HIGH);
    delay(2000);
    digitalWrite(ledPin2,LOW);
    flagFinish=0;
     
  }
}



